﻿// <auto-generated />
using System;
using Accounting.API.DataContext;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using Npgsql.EntityFrameworkCore.PostgreSQL.Metadata;

namespace Accounting.API.Migrations
{
    [DbContext(typeof(AccountingDataContext))]
    [Migration("20190414144418_init3")]
    partial class init3
    {
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.SerialColumn)
                .HasAnnotation("ProductVersion", "2.2.4-servicing-10062")
                .HasAnnotation("Relational:MaxIdentifierLength", 63);

            modelBuilder.Entity("Accounting.API.DataContext.AccountCategory", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<string>("AccountCategoryCode")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<string>("AccountCategoryName")
                        .IsRequired()
                        .HasMaxLength(64);

                    b.Property<string>("CreatedBy")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<DateTime>("CreatedDate");

                    b.Property<string>("ModifiedBy")
                        .HasMaxLength(24);

                    b.Property<DateTime?>("ModifiedDate");

                    b.Property<string>("Notes")
                        .HasMaxLength(512);

                    b.Property<byte>("RowStatus");

                    b.Property<byte[]>("RowVersion")
                        .IsRequired();

                    b.HasKey("Id");

                    b.HasIndex("AccountCategoryCode")
                        .IsUnique();

                    b.ToTable("AccountCategories");
                });

            modelBuilder.Entity("Accounting.API.DataContext.AccountType", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<string>("AccountCategoryCode")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<string>("AccountCategoryName")
                        .IsRequired()
                        .HasMaxLength(64);

                    b.Property<string>("CreatedBy")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<DateTime>("CreatedDate");

                    b.Property<string>("ModifiedBy")
                        .HasMaxLength(24);

                    b.Property<DateTime?>("ModifiedDate");

                    b.Property<string>("Notes")
                        .HasMaxLength(512);

                    b.Property<byte>("RowStatus");

                    b.Property<byte[]>("RowVersion")
                        .IsRequired();

                    b.HasKey("Id");

                    b.HasIndex("AccountCategoryCode")
                        .IsUnique();

                    b.ToTable("AccountTypes");
                });

            modelBuilder.Entity("Accounting.API.DataContext.ChartOfAccount", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<Guid>("AccountCategoryId");

                    b.Property<string>("AccountCode")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<byte>("AccountLevel");

                    b.Property<string>("AccountName")
                        .IsRequired()
                        .HasMaxLength(128);

                    b.Property<Guid>("AccountTypeId");

                    b.Property<string>("CreatedBy")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<DateTime>("CreatedDate");

                    b.Property<byte?>("DefaultValue");

                    b.Property<bool>("IsAccountDetail");

                    b.Property<string>("ModifiedBy")
                        .HasMaxLength(24);

                    b.Property<DateTime?>("ModifiedDate");

                    b.Property<string>("Notes")
                        .HasMaxLength(512);

                    b.Property<Guid?>("ParentId");

                    b.Property<byte>("RowStatus");

                    b.Property<byte[]>("RowVersion")
                        .IsRequired();

                    b.Property<string>("SchemaCode")
                        .IsRequired()
                        .HasMaxLength(5);

                    b.HasKey("Id");

                    b.HasIndex("AccountCategoryId");

                    b.HasIndex("AccountCode")
                        .IsUnique();

                    b.HasIndex("AccountTypeId");

                    b.ToTable("ChartOfAccounts");
                });

            modelBuilder.Entity("Accounting.API.DataContext.ChartOfAccount", b =>
                {
                    b.HasOne("Accounting.API.DataContext.AccountCategory", "AccountCategory")
                        .WithMany("ChartOfAccounts")
                        .HasForeignKey("AccountCategoryId")
                        .OnDelete(DeleteBehavior.Cascade);

                    b.HasOne("Accounting.API.DataContext.AccountType", "AccountType")
                        .WithMany("ChartOfAccounts")
                        .HasForeignKey("AccountTypeId")
                        .OnDelete(DeleteBehavior.Cascade);
                });
#pragma warning restore 612, 618
        }
    }
}
